# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, gamethread, cmdlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
monitor = es.import_addon('sam/core/monitor')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp = {'msg':0}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMD
	cmdlib.registerServerCommand('sam_bombstatus_msgtype', typeCMD, 'SAM CMD')

	# CFG
	lib = {'sam_bombstatus_msgtype':{'value':temp['msg'],'description':'If 0 messages will be displayed as hudhint, if 1 as center messages.'},
		   'addon':monitor.get('bombstatus','name')}
	monitor.cfg('bombstatus', lib)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMD
	cmdlib.unregisterServerCommand('sam_bombstatus_msgtype')

	# CANCEL DELAY
	gamethread.cancelDelayed('sam_bomb_timer')

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def loop(SEC):
	if temp['msg'] == 0: func.hudhint('#all', '## BOMB PLANTED ##\nExplosion in %s second/s!' % SEC)
	else: func.centermsg('#all', '## BOMB PLANTED: Explosion in %s seconds ##' % SEC)
	if SEC != 0: gamethread.delayedname( 1, 'sam_bomb_timer', loop, (SEC - 1))

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def bomb_planted(EV): loop(int(es.ServerVar('mp_c4timer')))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def bomb_defused(EV):
	if temp['msg'] == 1: func.centermsg('#all', '## BOMB DEFUSED ##')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def bomb_exploded(EV):
	if temp['msg'] == 1: func.centermsg('#all', '## BOMB EXPLODED ##')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(ev): gamethread.cancelDelayed('sam_bomb_timer')

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def typeCMD(args):
	if args:
		args = ' '.join(args)
		if args.isdigit():
			args = int(args)
			if args > 0: temp['msg'] = 1
			else: temp['msg'] = 0

# =============================================================================== #